using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SLTMTitleRunTime;

namespace FDTitleCSharp
{
	public partial class Form1 : Form
	{

		private SLTMTitleRunTime.ISLTMTitleRunTimeMgr titleMgr = null;
		private SLTMTitleRunTime.ISLTMTitleRunTime3 titleObjectCurr = null;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{

		}

		private void BrowseProject_Click(object sender, EventArgs e)
		{
			if (titleMgr == null) {
				titleMgr = new SLTMTitleRunTime.TitleProjectMgr();
			}
			openFileDialog1.Filter = "TitleProject Files(*.SlTitleProj)|*.SlTitleProj|All Files|*.*";
			openFileDialog1.FileName = tbProjectFile.Text;
			if (openFileDialog1.ShowDialog(this) == System.Windows.Forms.DialogResult.OK) {
				tbProjectFile.Text = openFileDialog1.FileName;
				try {
					titleMgr.Init(tbProjectFile.Text, 0);
					tbNumObjects.Text = titleMgr.NumObjects.ToString();
					lbObjects.Items.Clear();
					for (int i = 0; i < titleMgr.NumObjects; i++) {
						lbObjects.Items.Add(titleMgr.GetName(i));
					}
					if (titleMgr.NumObjects > 0) {
						lbObjects.SelectedIndex = 0;
					}
				}
				catch (Exception err) {
					MessageBox.Show(this, err.Message);
					lbObjects.Items.Clear();
					titleMgr.Uninit();
					titleMgr = null;
				}
			}

		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			if (titleObjectCurr != null) {
				try {
					double currTime;
					double restTime;
					double allDuration;
					bool loopped;
					titleObjectCurr.GetPlayInfo(out currTime, out restTime, out allDuration, out loopped);
					tbGlobalTime.Text = currTime.ToString("F2");
					tbRestTime.Text = restTime.ToString("F2");
					tbDuration.Text = allDuration.ToString("F2");
					if (loopped) {
						tbLoopped.Text = "Loopped";
					}
					else {
						tbLoopped.Text = "Not Loopped";
					}
					tbStatus.Text = titleObjectCurr.Status.ToString();
				}
				catch { }
 			}
 		}

		private void lbObjects_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (titleMgr != null) {
				try {
					titleObjectCurr = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(lbObjects.SelectedIndex);
					tbCurrName.Text = titleObjectCurr.Name;
					tbTask.Text = titleObjectCurr.TaskFileName;
				}
				catch (Exception err)  {
					MessageBox.Show(err.Message);
				}
			}
		}

		private void StartAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null) 
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					ISLTMTitleRunTime3 obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Start(0, 0.5);
				}
				catch (Exception err) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void StopAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null)
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					ISLTMTitleRunTime3 obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Stop(0, 0.5);
				}
				catch (Exception err) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void AbortAll_Click(object sender, EventArgs e)
		{
			if (titleMgr == null)
				return;
			int count = titleMgr.NumObjects;
			for (int i = 0; i < count; i++) {
				try {
					ISLTMTitleRunTime3 obj = (ISLTMTitleRunTime3)titleMgr.GetRunTimeInterface(i);
					obj.Abort(0.5);
				}
				catch (Exception err) {
					//MessageBox.Show(err.Message);
				}
			}
		}

		private void BrowseTask_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			openFileDialog1.Filter = titleObjectCurr.TaskFileMask + "All Files|*.*";
			openFileDialog1.FileName = tbTask.Text;
			if (openFileDialog1.ShowDialog(this) == System.Windows.Forms.DialogResult.OK) {
				tbTask.Text = openFileDialog1.FileName;
				try {
					titleObjectCurr.LoadTask(tbTask.Text);
				}
				catch (Exception err) {
					MessageBox.Show(err.Message);
				}
			}
		}

		private void Reload_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				titleObjectCurr.LoadTask(tbTask.Text);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Start_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)startTime.Value;//Double.Parse(startTime.Value, System.Globalization.CultureInfo.InvariantCulture);
				//time = -time;
				titleObjectCurr.Start(time, 0.5);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Stop_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)stopTime.Value;//Double.Parse(stopTime.Value, System.Globalization.CultureInfo.InvariantCulture);
				//time = -time;
				titleObjectCurr.Stop(time, 0.5);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void Abort_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				double time = (double)abortDuration.Value;//Double.Parse(abortDuration.Value, System.Globalization.CultureInfo.InvariantCulture);
				titleObjectCurr.Abort(time);
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void ShowProperties_Click(object sender, EventArgs e)
		{
			if (titleObjectCurr == null)
				return;
			try {
				ISLTMTitleObjectProperties props = titleObjectCurr as ISLTMTitleObjectProperties;
				if (props != null) {
					props.ShowDialog(this.Handle);
				}
			}
			catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}

		private void startTime_ValueChanged(object sender, EventArgs e)
		{

		}
	}
}