/*
 * $Id: TMDriverConsts.h,v 1.27 2002/07/10 10:32:43 nik Exp $
 */

#ifndef TMDRIVERCONSTS_H
#define TMDRIVERCONSTS_H

// Statistics Counters Definition

enum {
	max_stat_cnts = 100
};

/**
 *  
 */
typedef struct one_cnt_type {
	/**
     *  
     */
	long cnt;
	/**
     *   
     */
	char s[32];
} one_cnt_type;

typedef one_cnt_type all_cnts_type[max_stat_cnts];

enum {
	max_io_wire_types = 100
};

/**
 *         
 * 
 * @see tmc_get_inputs_list
 */
typedef struct SLTM_IO_Desc {
	/**
     * 
     */
	long dsc[8];
	/**
     *  
     */
	char s[64];
} SLTM_IO_Desc;

typedef SLTM_IO_Desc SLTM_IO_Descs[max_io_wire_types];

/**
 *     
 * 
 * @see tmc_set_video_standard
 * @see tmc_get_standard_list
 * @since 2003-03-26
 */
typedef struct SLTM_Standard_Desc {
	/**
     * id 
     */
	long stanard_id;
	/**
     *  
     */
	char name[20];
} SLTM_Standard_Desc;

/**
 *     
 */
enum eMax_params_count {
	tmc_max_params_count = 32
};

/**
 *       fd3000
 */
enum eHostCommands {
	tmc_get_version,
	tmc_get_status,
	/**
     *     - /
     * 
     * @see tmc_get_standard_list
     * @see CSLTMVideoStandart
     */
	tmc_set_video_standart,
	tmc_get_video_standart,
	tmc_set_video_size,
	tmc_get_video_size,
	tmc_load_key_table,
	tmc_grab_shot_data,
	tmc_start_grab_streaming,
	tmc_stop_grab_streaming,
	tmc_get_grab_format,
	tmc_set_vfilter,			// old dummy command
	tmc_get_vfilter,			// old dummy command
	tmc_set_hfilter,
	tmc_get_hfilter,
	tmc_set_color_correction,
	tmc_get_color_correction,
	tmc_set_alfa_edge,
	tmc_get_alfa_edge,
	tmc_set_key_table_bank,
	tmc_get_key_table_bank,
	/**
     *    
     * 
     * @see CSLTMMixerOutput
     */
	tmc_set_mixer_output,
	tmc_get_mixer_output,
	tmc_set_artist_source,
	tmc_get_artist_source,
	tmc_set_background_alfa_usage,	// old dummy command
	tmc_get_background_alfa_usage,	// old dummy command
	tmc_set_artist_alfa_usage,	// old dummy command
	tmc_get_artist_alfa_usage,	// old dummy command
	tmc_get_cnts,
	tmc_get_diags_cnts,			// old dummy command ???
	tmc_set_input_value,
	tmc_get_input_value,
	tmc_set_output_value,
	tmc_get_output_value,
	tmc_put_static_scn,			// old dummy command
	tmc_set_mpeg_fifo,			// old dummy command
	tmc_clear_mpeg_fifo,		// old dummy command
    /**
     * synchro switch
     * 
     *       
     */
	tmc_set_xo,tmc_get_xo,
	tmc_start_fifo_grab_streaming,
	tmc_stop_fifo_grab_streaming,
	tmc_mpeg_fifo_pause,		// old dummy command
	tmc_mpeg_fifo_continue,		// old dummy command
	tmc_mpeg_fifo_state,		// old dummy command
	tmc_set_xo_in_mpeg_frame,	// old dummy command
	tmc_set_packet_fifo,
	tmc_clear_packet_fifo,
	tmc_set_iic_reg,
	tmc_get_iic_reg,
	tmc_get_input_value_range,
	tmc_get_output_value_range,
	/**
     *    
     * 
     * @see SLTM_IO_Desc
     * @see EHostCommand::s_get_some_list
     */
	tmc_get_inputs_list,
	/**
     *     
     * 
     * @see SLTM_IO_Desc
     * @see EHostCommand::s_get_some_list
     */
	tmc_get_outputs_list,
	tmc_set_genlock,
	tmc_get_genlock,
	tmc_set_digital_io1,
	tmc_get_digital_io1,
	tmc_set_digital_io2,
	tmc_get_digital_io2,
	tmc_registration,
	tmc_set_iic_focus_reg,
	tmc_get_iic_focus_reg,
	tmc_check_soft,
	tmc_check_func,
	tmc_sound,
	tmc_color_phase_reset,
	tmc_mixer4,
	/**
     *  FIFO
     * 
     * @see FIFOCommand
     */
	tmc_fifo,
	tmc_scn,
	tmc_get_boards_numbers,
	/**
     *     PCI
     */
	tmc_deactivate_sgdma_handle,
	tmc_get_dvm_state,
	tmc_get_field_counter,
	/**
     *    
     * 
     * time filter comand ( tmc_set_time_filter ) parameters:
     * command, type 0..4, min threshold, max threshold, min alpha, max alpha, oneAlphaBuffer
     *  types: CTimeFilter::eTFilterMode
     * 0 -   0
     * 1 -    1
     * 2 -    Y  1:1:1
     * 3 -    Y  1:2:1
     * 
     * @see CTimeFilter::eTFilterMode
     * @see SLTMTimeFilterType
     */
	tmc_set_time_filter,
	tmc_get_time_filter,
	/**
     *     
     * 
     * @see tmc_set_video_standart
     * @see tmc_get_video_standart
     * @since 2003-03-28
     */
	tmc_get_standard_list,
	/**
     *   .       .
     * 
	 * , , rate, scale  (50/1=PAL 60000/1001=NTSC)
	 * @since 2003-03-28
     */
	tmc_get_field_format,
	/**
     *   Y      
     * @see EHostCommand::a_get_pixels
     * @since 2003-10-01
     */
	tmc_get_pixels,

	/**
     *   VBI  .
     *   .
     *      .   -1  VBI.
     * 
     * @see EHostCommand::s_set_vbi_lines_pass
     * @since 2003-11-28
     */
	tmc_get_vbi_lines_pass, tmc_set_vbi_lines_pass,
    /**
     *       PCI DMA.
     *       DEBUG_PCI.
     *   retSize -1
     * 
     * @see EHostCommand::s_get_some_list
     */
	tmc_get_debug_buffer,
   /**
     * synchro switch
     * 
     *       
     * @see EHostCommand::a_synchro_switch
     */
    tmc_set_xo_delayed, tmc_get_xo_delayed,
  /**
     *    .
     *   . 
     * 
     * 1 - .
     * 2 -  Y
     * 3 -  UV
     * 
     *      1     .
     * 
     * @see EHostCommand::s_wme9_filter
     * @since 2004-06-28
     */
    tmc_get_wme9_filter,tmc_set_wme9_filter,
    /**
     *     
     * 
     * @see EHostCommand::v_wme9_qinterlace
     */
    tmc_get_wme9_qinterlace, tmc_set_wme9_qinterlace,
    /**
     *     
     * 
     * @see EHostCommand::v_clip_alphamask
     */
    tmc_set_clip_alphamask, tmc_get_clip_alphamask,

    /**
     *     RSA 
     * 
     * @see EHostCommand::s_enc_load
     */
    tmc_encr_load_keys,
    /**
     *   
     * 
     * @see EHostCommand::s_enc_load
     */
    tmc_encr_get_publickey,
    /**
     *  
     * 
     * @see EHostCommand::s_enc_open 
     *   handle
     */
    tmc_encr_close,
    /**
     *      
     *   .  memIDSrc     
     * 
     * @see EHostCommand::s_enc_open 
     */
    tmc_encr_open_encode_key,
    /**
     *     
     * 
     * @see EHostCommand::s_encode
     */
    tmc_encr_encode,
    /**
     *       
     * 
     * @see EHostCommand::s_enc_open 
     */    
    tmc_encr_open_decode_key,
    /**
     *     
     * 
     * @see EHostCommand::s_encode
     */
    tmc_encr_decode,

    /**
     *        handle     
     * 
     * @see EHostCommand::s_default_picture
     */
    tmc_put_default_picture
};

enum { RANGE_MIN = 0, RANGE_MAX = 1, RANGE_DEF = 2 };

typedef enum sltmGenlock_t {
	tmc_genlock_master,
	tmc_genlock_a,
	tmc_genlock_b
} sltmGenlock_t;

/**
 *     
 */
typedef enum sltm_digital_io1_t {
	tmc_digital_io1_none,
	tmc_digital_io1_output_1,
	tmc_digital_io1_output_2
} sltm_digital_io1_t;

/**
 *     /
 */
typedef enum sltm_digital_io2_t {
	tmc_digital_io2_none,
	tmc_digital_io2_output,
	tmc_digital_io2_input
} sltm_digital_io2_t;

/**
 * SLTMInput Values Definitions
 *   .  .
 * p[1]  
 * 
 * @see tmc_get_input_value
 * @see tmc_set_input_value
 */
typedef enum SLTMInputValuesType {
	tmc_input_standart,
	tmc_input_1_type,
	tmc_input_2_type,
	tmc_input_vtrc,
	tmc_input_vpref,
	tmc_input_vcross,
	tmc_input_vhue,
	tmc_input_vsat,
	tmc_input_vbright,
	tmc_input_vcontr,
	tmc_input_vcory,
	tmc_input_vaper,
	tmc_input_vband,
	tmc_input_vnoise,
	tmc_input_gain,
	tmc_input_u_gain,
	tmc_input_v_gain,
	tmc_input_gain_lock,

	  /**
       *    CVBS
       * @since 2003-03-31
       * 
       * @deprecated  
       */
	tmc_input_vhue_1, tmc_input_vhue_2,
	  /**
       *  CVBS     
       */
	tmc_input_vsat_1, tmc_input_vsat_2,
	tmc_input_vbright_1, tmc_input_vbright_2,
	tmc_input_vcontr_1, tmc_input_vcontr_2,
    /**
     *  YUV    
     * 
     * @see tmc_input_y_gain_1
     */
	tmc_input_u_gain_1, tmc_input_u_gain_2,
	tmc_input_v_gain_1, tmc_input_v_gain_2,

    /**
     *    
     */
	tmc_chroma_delay_1,
	tmc_chroma_delay_2,
    /**
     *      
     */
	tmc_hstart_1,
	tmc_hstart_2,
	tmc_check_reg,
	tmc_input_dio,
	/**
     *  YUV    
     * 
     * @see tmc_input_u_gain_1
     */
	tmc_input_y_gain_1, tmc_input_y_gain_2,
    /**
     *  Closed Caption  
     */
    tmc_input_closed_caption,
    /**
     *    viSwapInputFields -       7118 - 
     *  -   SDI
     */
    tmc_swap_input_fields_1,
    tmc_swap_input_fields_2,
	// that's all
	tmc_input_total_values
} SLTMInputValuesType;

/**
 *     -   
 */
typedef enum sltmVideoAnalogAdapter_t {
	SLTMvaaCVBS = 1,
	SLTMvaaSvideo = 2,
	SLTMvaaYC = 2,
	SLTMvaaYUV = 8,
	SLTMvaaRGB = 16,
	SLTMvaaSvideo_Alpha = 32,
	SLTMvaaYUV_Alpha = 64,
	SLTMvaasYUV_Alpha = 65, // sKey   Y
	SLTMvaaRGB_Alpha = 128,
	SLTMvaaColorBarYC = 256,
	SLTMvaaColorBarYUV = 257,
	SLTMvaaColorBarRGB = 258,
	SLTMvaaYUVSync = 512,
	SLTMvaaRGBSync = 513,
	SLTMvaaRgB_Alpha = 514,
	SLTMvaaDigital = 1024,
    /**
     *  401  ASI 
     */
    SLTMvaaASI  = 2048
} sltmVideoAnalogAdapter_t;

/**
 *     
 * 
 * @see SLTMOutput
 * @see tmc_set_output_value
 * @see tmc_get_output_value
 */
typedef enum SLTMOutputValuesType {
	tmc_output_slave,
	tmc_output_adapter_type,
	tmc_genlock_offset,
	tmc_dummy_1,
	tmc_output_dio,
	tmc_output_xoffset,
	tmc_output_yoffset,
	tmc_output_color_phase,
    /**
     *  Closed Caption  
     */
    tmc_output_closed_caption,
	tmc_output_total_values
} SLTMOutputValuesType;

/**
 * Video Standart.  .   
 * 
 * @see tmc_get_standard_list
 * @deprecated   tmc_get_standard_list
 */
typedef enum CSLTMVideoStandart {
	STD_PAL = 0,
	STD_NTSC = 1
} CSLTMVideoStandart;

// Point to grab data from
typedef enum CSLTMDataSource {
	DTP_MixerInputA,
	DTP_MixerInputB,
	DTP_MixerOutput,
    DTP_AsiGraber
} CSLTMDataSource;

// Geometry of VideoData in Trimedia
typedef enum CSLTMVideoSize {
	SLTM_FullFull,				// x,y
	SLTM_HalfFull
} CSLTMVideoSize;

/**
 *   
 * 
 * @see tmc_input_1_type
 * @see tmc_input_2_type
 */
typedef enum CDecoderInputs {
	SLTM_VHS_0,
	SLTM_VHS_1,
	SLTM_VHS_2,
	SLTM_VHS_3,
	SLTM_VHS_4,
	SLTM_VHS_5,
	SLTM_SVHS_0,
	SLTM_SVHS_1,
	SLTM_SVHS_2,
	SLTM_YUV,
	SLTM_CVBS1, SLTM_CVBS2, SLTM_CVBS3,
	SLTM_CVBS4, SLTM_CVBS5, SLTM_CVBS6,
	SLTM_CVBS7, SLTM_CVBS8, SLTM_CVBS9,
	SLTM_CVBS10, SLTM_CVBS11, SLTM_CVBS12,
	SLTM_YC1, SLTM_YC2, SLTM_YC3,
	SLTM_YC4, SLTM_YC5, SLTM_YC6,
	SLTM_YUV1, SLTM_YUV2, SLTM_YUV3,
	SLTM_YUVS1, SLTM_YUVS2, SLTM_YUVS3,
	SLTM_RGB1, SLTM_RGB2, SLTM_RGB3,
	SLTM_RGBS1, SLTM_RGBS2, SLTM_RGBS3,
	SLTM_DIGITAL
} CDecoderInputs;

typedef enum CSLTMAlfaVFilter {
	SLTM_AlfaVFilterOff,
	SLTM_AlfaVFilterOn
} CSLTMAlfaVFilter;

typedef enum CSLTMAlfaHFilter {
	SLTM_AlfaHFilterOff,
	SLTM_AlfaHFilter3,			// 3 Pixel filter
	SLTM_AlfaHFilter5			// 5 Pixel filter
} CSLTMAlfaHFilter;

/**
 *  
 * 
 * @see tmc_set_mixer_output
 * @see tmc_get_mixer_output
 */
typedef enum CSLTMMixerOutput {
	SLTM_MOArtist,
	SLTM_MOArtistAndAlfa,
	SLTM_MOAlfa,
	SLTM_MOBackground,
	SLTM_MOFulllMix
} CSLTMMixerOutput;

typedef enum CSLTMOFields {
	SLTM_FFirst,
	SLTM_FSecond,
	SLTM_FBoth
} CSLTMOFields;

/**
 *     
 */
typedef enum CSLTM_ArtistDataSource {
    /**
     * Line #1
     */
	SLTM_ASA,
    /**
     * Line #2
     */
	SLTM_ASB,
    /**
     * Line #1 + Alfa
     */
	SLTM_ASAAlfa,
    /**
     * Line #2 + Alfa
     */
	SLTM_ASBAlfa,
    /**
     * Line #1+Alfa #1 + Line #2
     */
	SLTM_ASAAlfaB,				// Key for A
    /**
     * Line #2+Alfa #2 + Line #1
     */
	SLTM_ASBAlfaA,				// Key for B
    /**
     * Line #1 + Line #2
     */
	SLTM_ASAB,
    /**
     * Line #2 + Line #1
     */
	SLTM_ASBA
} CSLTM_ArtistDataSource;

/**
 *       
 */
typedef enum CSLTMRGBAlfaFormat {
	SLTM_FRGBAlfa,
	SLTM_FBGRAlfa,
	SLTM_FYUV422,
	SLTM_FYUV422a,
	SLTM_F16YUV,
	SLTM_F16YAUV,
	SLTM_F16YUVYUV,
	SLTM_F16YAUVYUV,
	SLTM_FYUV420,
	/**
     *     Y
     */
	SLTM_FYUV422aInv,
	/**
     *  RLE    . 
     *  long   RLE
     */
	SLTM_F16YAUV_RLE,
    /**
     *  MPEG  ASI
     */
    SLTM_ASIfmt
} CSLTMRGBAlfaFormat;

typedef enum CSLTM_PacketFlags {
	SLTM_ChanInv = 0x00800000,
	SLTM_ChanA = 0x00400000,
	SLTM_ChanB = 0x00200000,
	SLTM_AlphaEnable = 0x00100000,
	SLTM_ChanNumberMask = 0x00F00000,
	SLTM_ChanNumberShift = 20
} CSLTM_PacketFlags;

enum eXOMask {
	XO_KEYON_MASK = 1 << 16,
	XO_KDF0_MASK = 2 << 16,
	XO_KDF1_MASK = 4 << 16,
	XO_KTBNK_MASK = 8 << 16,
	XO_ALEN_MASK = 16 << 16,
	XO_BEN_MASK = 32 << 16,
	XO_AEN_MASK = 64 << 16,
	XO_CHIN_MASK = 128 << 16
};

enum eXOShift {
	XO_KEYON_BIT_SHIFT = 16,
	XO_KDF0_BIT_SHIFT,
	XO_KDF1_BIT_SHIFT,
	XO_KTBNK_BIT_SHIFT,
	XO_ALEN_BIT_SHIFT,
	XO_BEN_BIT_SHIFT,
	XO_AEN_BIT_SHIFT,
	XO_CHIN_BIT_SHIFT
};

typedef enum tmslFIFOReadState_t {
	TMSL_FIFOREAD_STOPED,
	TMSL_FIFOREAD_PAUSED,
	TMSL_FIFOREAD_PAUSING,
	TMSL_FIFOREAD_RUNING
} tmslFIFOReadState_t;

#define XO_KEYON(x) 	( ( (x) ? 1 << XO_KEYON_BIT_SHIFT : 0 ) | (XO_KEYON_MASK>>16))
#define XO_HFILTER(x)	( ( (x) & 3  << XO_KDF0_BIT_SHIFT ) | ((XO_KDF0_MASK|XO_KDF1_MASK)>>16))
#define XO_BANK(x)	( ( (x) ? 1 << XO_KTBNK_BIT_SHIFT : 0) | (XO_KTBNK_MASK>>16))
#define XO_ALPHA(x)	( ( (x) ? 1 << XO_ALEN_BIT_SHIFT : 0 ) | (XO_ALEN_MASK>>16))
#define XO_AEN(x)	( ( (x) ? 1 << XO_AEN_BIT_SHIFT : 0 ) | (XO_AEN_MASK>>16))
#define XO_BEN(x)	( ( (x) ? 1 << XO_BEN_BIT_SHIFT : 0 ) | (XO_BEN_MASK>>16))
#define XO_SWAP(x)	( ( (x) ? 1 << XO_CHIN_BIT_SHIFT: 0 ) | (XO_CHIN_MASK>>16))

typedef enum tmslI2Caddress {
	TMSL_I2C_VideoInput1 = 0x42,
	TMSL_I2C_VideoInput2 = 0x40,
	TMSL_I2C_VideoOutput = 0x88
} tmslI2Caddress;

/**
 *     XILINX
 * 
 *      XILINX
 */
#define bitFileBufferSize 42000
#define initStructTag  "bitFileBuffer"

#define bitNameLen 40
#define bitNameNum 10

struct bitName {
	unsigned int id;
	char name[bitNameLen];
};

typedef struct bitFileBuffer {
	struct bitName bitnames[bitNameNum];
	unsigned int size;
	/**
     *     XILINX
     */
	unsigned char data[bitFileBufferSize];
} bitFileBuffer_t;

typedef struct debugBufferStruct {
	char *addr;
	unsigned int size;
	unsigned int pos;
	unsigned int level;
} debugBufferStruct_t;

typedef struct soundInit {
	void *soundInitAddr;
	unsigned int soundInitSize;
} soundInit_t;

typedef struct initStruct {
	/**
     *     SLTMSRVS   
     */
	char tag[16];
	/**
     *   
     */
	unsigned int size;
	/**
     *   XILINX
     */
	struct bitFileBuffer bitBuffer;
	debugBufferStruct_t debugBuffer;
	unsigned int memoryAddressLimit;
	soundInit_t soundInit;
	unsigned int numberOfFIFOs;
	unsigned int suicide;
	unsigned int numberOfScns;
	/**
     *       XILINX
     */
	unsigned int xilinxSize;
	/**
     * SGDMA HAndle         XILINX
     */
	unsigned int xilinxSgdmahandle;
} initStruct_t;

/*
 * mixer4 commands
 */
typedef enum Mixer4Command {
	MIX4_SET_MODE,
	MIX4_GET_MODE,
	MIX4_CHANGE_MODE,
	MIX4_CHANGE_MODE_AT_COUNTER
} Mixer4Command_t;
/*
 * tmc_mixer4, set_mode, mode, field_index(0/1)
 * tmc_mixer4, get_mode, *mode
 * tmc_mixer4, change_mode, mode, mode_mask, field_index
 * tmc_mixer4, change_mode_at_counter, mode, mode_mask, field_index, lowticksGlobal, hiticksGlobal
 */

/*
 *  FIFO 
 */
typedef enum FIFOState {
	FIFO_NONE,
	/**
	 *   
	 */
	FIFO_STOPPED,
	/**
	 *   ,     
	 */
	FIFO_HOLDING,
	/**
     *         FIFO_HOLDING
     */
	FIFO_PAUSED,
	/**
     *     
     */
	FIFO_PLAYING,
	/**
     *   
     */
	FIFO_PLAYING_ALL,
	FIFO_STATE_ERROR
} FifoState_t;

/**
 *   .
 *   target & host
 * 
 * @see tmc_fifo
 */
typedef enum FIFOCommand {
	/**
     *  FIFO  handle !=0 
     *  FIFO  handle ==0 
     * FIFO    HOLDING
     */
	FIFO_RESET,
	FIFO_SET_STATE,
	FIFO_GET_STATE,
	FIFO_GET_COUNTERS,
	FIFO_SET_STATE_AT_COUNTER,
	FIFO_GET_PLAYED_COUNTER,
	/**
    *       FIFO
    *  1   FIFO
    *  2    
    * @see EHostCommand::e_all_req
    * @since 2003-05-08
    */
	FIFO_QC_GET_SKIP_FIELDS,
	/**
     *        
     * a_fifo_state.handle     
     *                      (long) 0 
     * a_fifo_state.state    
     * 
     * @since 2003-10-01
     * @see sltmFifoHeader.start_fifo
     * @see EHostCommand::a_fifo_state
     */
	FIFO_SET_STATE_AT_HOSTVAR
} FIFOCommand_t;
/*
 * tmc_fifo, reset, number, sgdma, direction
 * tmc_fifo, set_state, number, state, field_index(0/1)
 * tmc_fifo, get_state, number, *state, *direction
 * tmc_fifo, get_counters, number, *lowticksLocal, *hiticksLocal, *lowticksGlobal, *hiticksGlobal
 * tmc_fifo, set_state_at_counter, number, state, field_index, lowticksGlobal, hiticksGlobal
 * tmc_fifo, get_played_counter, number, *lowticksData, *hiticksData, *lowticksGlobal, *hiticksGlobal
 */

/**
 * Scn commands
 * 
 * @see EHostCommand::s_scenes_cmd
 */
typedef enum ScnCommand {
    /**
     *   FIFO  
     */
	SCN_SET_FIFO,
    /**
     *   FIFO  
     */
	SCN_GET_FIFO,
    /**
     *   FIFO    
     */
	SCN_SET_FIFO_AT_COUNTER,
    /**
     *       fieldIdx = 0
     *    fieldIdx = 1. 
     *        
     *    
     */
    SCN_SET_FIELD_REPEAT
} ScnCommand_t;
/*
 * tmc_scn, set_fifo, scn_number, fifo_number, field_index(0/1)
 * tmc_scn, get_fifo, scn_number, *fifo_number
 * tmc_scn, set_fifo_at_counter, scn_number, fifo_number, field_index, lowticksGlobal, hiticksGlobal
 */

/**
 *    
 * 
 * @see tmc_set_time_filter
 * @see tmc_get_time_filter
 */
typedef enum {
	/**
     * 
     */
	SLTM_TimeFilter_None,
	/**
     * 
     */
	SLTM_TimeFilter_010,
	/**
     * +
     */
	SLTM_TimeFilter_111,
	/**
     * +
     */
	SLTM_TimeFilter_121,
	/**
     *   
     */
	SLTM_TimeFilter_Edge
} SLTMTimeFilterType;

/**
 *     VBI   
 *   -     CC  
 */
typedef enum eGraberMode {
	/**
     *   Closed Capt6ion 
     *    = (v & evbiUseCC) - 1
     */
	egmUseCC = 0x03,
	/**
     *  CC 
     */
	egmGrabCC = 0x4,
	/**
     *  VITC
     */
	egmGrabVITC = 0x08,
    /**
     *    FIFO 
     */
    egmGrabSound = 0x10
} eGraberMode;

/**
 *       .
 */
#define ERROR_FIFO_NUMBER   ~1
#define ERROR_BAD_FIFO_HANDLE ~2
#define ERROR_FIFO_SET_INVALID_STATE ~3
#define ERROR_INCORRECT_SUBCOMMAND ~4
#define ERROR_SCN_NUMBER ~5
#define ERROR_CREDENTIAL ~6
#define ERROR_STANDARD ~7
#define ERROR_OUTPUT_TYPE ~8
#define ERROR_INPUT_TYPE ~9
#define ERROR_NOT_IMPLEMENTED ~10
#define ERROR_MIXER_COMMAND ~11
#define ERROR_FIFO_WRITE ~12
#define ERROR_IIC ~13
#define ERROR_START_GRABER ~14
#define ERROR_TMLOCKED ~15
#define ERROR_GRABER_STATE ~16
#define ERROR_INVALID_PARAM ~17
#define ERROR_GRABBING ~18
#define ERROR_TMNOMEMORY ~19
#define ERROR_VBI_MODE  ~20
#define ERROR_MIXER ~21

#define WARNING_VBI_OFF 1
#define WARNING_DUMP_GRAB 2

#endif							/* TMDRIVERCONSTS_H */
